// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('app', ['ionic', 'ngCordova'])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    // if (window.StatusBar) {
    //   // org.apache.cordova.statusbar required
    //   StatusBar.styleDefault();
    // }
  });
})

.config(function($stateProvider, $urlRouterProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  // $stateProvider

  // // setup an abstract state for the tabs directive
  //   .state('tab', {
  //   url: '/tab',
  //   abstract: true,
  //   templateUrl: 'templates/tabs.html'
  // })

  // // Each tab has its own nav history stack:

  // .state('tab.dash', {
  //   url: '/dash',
  //   views: {
  //     'tab-dash': {
  //       templateUrl: 'templates/tab-dash.html',
  //       controller: 'DashCtrl'
  //     }
  //   }
  // })

  // .state('tab.chats', {
  //     url: '/chats',
  //     views: {
  //       'tab-chats': {
  //         templateUrl: 'templates/tab-chats.html',
  //         controller: 'ChatsCtrl'
  //       }
  //     }
  //   })
  //   .state('tab.chat-detail', {
  //     url: '/chats/:chatId',
  //     views: {
  //       'tab-chats': {
  //         templateUrl: 'templates/chat-detail.html',
  //         controller: 'ChatDetailCtrl'
  //       }
  //     }
  //   })

  // .state('tab.account', {
  //   url: '/account',
  //   views: {
  //     'tab-account': {
  //       templateUrl: 'templates/tab-account.html',
  //       controller: 'AccountCtrl'
  //     }
  //   }
  // });

  // // if none of the above states are matched, use this as the fallback
  // $urlRouterProvider.otherwise('/tab/dash');

  // $urlRouterProvider.when('', '/tabs');
  $urlRouterProvider.otherwise('/tab/welcome');

  $stateProvider
      .state('tab', {
        url: '/tab',
        abstract: true,
        templateUrl: 'templates/tabs.html'
      })
      .state('tab.welcome', {
        url: '/welcome',
        views: {
          'welcome-tab': {
            templateUrl: 'templates/welcome.html',
            controller: 'WelcomeCtrl'
          }
        }
      })
      .state('tab.home', {
        url: '/home',
        views: {
          'home-tab': {
            templateUrl: 'templates/home.html',
            // controller: 'homeCtrl'
          }
        }
      })
      .state('tab.schedule', {
        url: '/schedule',
        views: {
          'schedule-tab': {
            templateUrl: 'templates/schedule.html',
            controller: 'ScheduleCtrl'
          }
        }
      })
      .state('tab.lecture', {
        url: '/lecture/:id',
        views: {
          'schedule-tab': {
            templateUrl: 'templates/speaker.html',
            controller: 'SpeakerCtrl'
          }
        }
      })
      .state('tab.speakers', {
        url: '/speakers',
        views: {
          'speakers-tab': {
            templateUrl: 'templates/speakers.html',
            // controller: 'speakersCtrl'
          }
        }
      })
      .state('tab.speaker', {
        url: '/speakers/:id',
        views: {
          'speakers-tab': {
            templateUrl: 'templates/speaker.html',
            controller: 'SpeakerCtrl'
          }
        }
      })
      .state('tab.news', {
        url: '/news',
        views: {
          'news-tab': {
            templateUrl: 'templates/news.html',
            // controller: 'newsCtrl'
          }
        }
      })
      .state('tab.about', {
        url: '/about',
        views: {
          'about-tab': {
            templateUrl: 'templates/about.html',
            // controller: 'aboutCtrl'
          }
        }
      });

})


.filter('moment', function() {
  return function(input) {
    return moment(input).format();
  };
})

// .filter('favorite', function() {
//   return function(list) {
//     console.log(list);
//     var filtered = list.filter(function (day) {

//     });
//     return filtered;
//   };
// })

.config(['$sceDelegateProvider', '$compileProvider', function($sceDelegateProvider, $compileProvider) {
    $sceDelegateProvider.resourceUrlWhitelist(['**']);
    $compileProvider.imgSrcSanitizationWhitelist(/^\s*(https?|ftp|file):|data:image\/|blob:/);
    $compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|tel|file|data|blob):/);
}])

.filter('trustedResource', ['$sce', function($sce) {
    return function(val) {
        return $sce.getTrustedResourceUrl(val);
    };
}])

.directive('tweet', function($compile, $parse) {
    return {
      restrict: 'E',
      replace: true,
      template: '<h3></h3>',
      link: function(scope, element, attr) {
        scope.$watch(attr.content, function() {
          element.html($parse(attr.content)(scope));
          $compile(element.contents())(scope);
        }, true);
      }
    }
  })

.controller('AppCtrl', function ($rootScope, $document, $scope, $state, $window, $ionicPopup, $cordovaStatusbar, $ionicModal, $ionicNavBarDelegate, $ionicPlatform, $cordovaLocalNotification, $timeout, Data) {
// console.log('AppCtrl', $scope);

    $scope.data = Data;
    $scope.news = Data.news;
    $scope.speakers = Data.speakers;
    $scope.now = new Date();
    $scope.scheduleTabs = {
      active: 0
    };
    $scope.$watch('data.formated', function (days, prev) {
      if (!prev && days && days.length) {
        var foundNextItem = false;
        days.forEach(function (day, index) {
          if (moment(day.date).isSame(moment(), 'd')) {
            $scope.scheduleTabs.active = index;
          }
          day.lectures.forEach(function (item) {
            if (!foundNextItem && moment(item.event.start).isAfter(moment(), 'm')) {
              foundNextItem = true;
              item.isNext = true;
            }
          });
        });
      }
    })

    $document.on('resume', function() {
        Data.reload();
    });

    $scope.hasFavorite = function (item) {
      var hasFeatured = false;
      if (item.locations) {
        item.locations.forEach(function (location) {
          if (!location.lectures) return;
          location.lectures.forEach(function (lecture) {
            if (lecture.favorite) {
              hasFeatured = true;
            }
          });
        });
      } else if (item.lectures) {
        item.lectures.forEach(function (lecture) {
          if (lecture.favorite) {
            hasFeatured = true;
          }
        });
      }
      return hasFeatured;
    };


    function setDate () {
      $timeout(function () {
        $scope.now = new Date();
        setDate();
      }, 60 * 1000);
    }

    setDate();

    // $scope.pn = [];
    // ['schedule', 'trigger', 'update', 'clear', 'clearall', 'cancel', 'cancelall', 'click'].forEach(function (ev) {
    //   $rootScope.$on('$cordovaLocalNotification:' + ev, function(event, notification, state) {
    //     $scope.pn.push({
    //       type: ev,
    //       data: notification
    //     });
    //   });
    //   $ionicPlatform.ready(function () {
    //     if (!window.cordova) return;
    //     cordova.plugins.notification.local.on(ev, function (notification, state) {
    //       $scope.pn.push({
    //         type: ev,
    //         data: arguments
    //       });
    //     });
    //   });
    // })
    // $scope.pn = [];
    $rootScope.$on('$cordovaLocalNotification:click', function(event, notification, state) {
      if (!notification || !notification.id) return;
      $timeout(function () {
        var item = Data.getById(notification.id).then(function (item) {
          if (!item) return;
          if (item.speaker.visible || item.event.visible) {
            // $state.transitionTo('tab.' + (speaker.visible ? 'speakers' : 'lecture'), { id: clicked.speaker });
            // window.location = '#tab/' + (speaker.visible ? 'speakers' : 'lecture') + '/' + clicked.speaker;
            window.location = '#/tab/' + (item.speaker.visible ? 'speakers' : 'lecture') + '/' + item.id;
          } else {
            $state.go('tab.schedule');
          }
        });
      }, 100);
    });

    $ionicPlatform.ready(function () {
      if (!window.cordova) return;
      $cordovaStatusbar.overlaysWebView(false);
      // // $cordovaStatusbar.styleBlackTranslucent();
      $cordovaStatusbar.styleHex('#384953');
      // // $cordovaStatusbar.style(0);
      // // $cordovaStatusbar.styleDefault();
      // if (window.StatusBar) {
      //   setTimeout(function () {
      //     (window as any).StatusBar.styleDefault();

      //   }, 5000);
      //   // $cordovaStatusbar.styleHex('#ffff00');
      // } else {
      //   $cordovaStatusbar.styleHex('#ff00ff');
      // }
    });
    function highlightStatusBar (status) {
      if (!window.cordova) return;
      // $cordovaStatusbar.styleHex(status ? '#EBEFF2' : '#ffffff');
    }
    $rootScope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
      highlightStatusBar(toState.name === 'tab.schedule');
    });

    $scope.savedNotifications = [];

    $scope.goToSchedule = function () {
      if (!$scope.savedNotifications.length) {
        $scope.goTo('tab.schedule');
      }
    };

    $scope.about = Data.about;
    $scope.schedule = Data.schedule;
    $scope.getSpeaker = Data.getSpeaker;
    $scope.calendars = Data.calendars;
    $scope.$watch(function () { return Data.hasCal; }, function (value) {
        $scope.hasCal = value;
    });

    $scope.debug = Data.debug;

    $scope.href = function(path) {
        window.open(path, '_self');
    }

    $scope.goTo = function(path) {
        $state.go(path);
    }

    $scope.goBack = function() {
        $ionicNavBarDelegate.back();
    };

    $scope.open = function(url) {
        window.open(encodeURI(url), '_system');
    }

    $scope.open1 = function(url) {
        window.open(url, '_system');
    }

    $scope.open2 = function(url) {
        window.open('http://www.google.com', '_system');
    }

    $scope.open3 = function(url) {
        window.open(url);
    }

    $scope.open11 = function(url) {
        window.open(encodeURI(url), '_system');
    }

    $scope.open12 = function(url) {
        window.open(encodeURI('http://www.google.com'), '_system');
    }

    $scope.open13 = function(url) {
        window.open(encodeURI(url));
    }

    $scope.showLocation = function(location) {
        $ionicPopup.alert({
            title: location,
            okText: 'Zatvori',
            content: '<img src="images/temp_map.gif" height="250" />'
        }).then(function(res) {

        });
    };

    $scope.favorite = function(lecture) {
        if (!lecture.favorite) {
          $scope.scheduleDelayedNotification(lecture);
        } else {
          $scope.cancelDelayedNotification(lecture);
        }
    };

    $scope.isFavorite = function (lecture) {
      if (lecture && angular.isDefined(lecture.favorite)) return lecture.favorite;
      if (!lecture || !lecture.id || !$scope.savedNotifications.length) return false;
      var inList = $scope.savedNotifications.filter(function (n) {
        return lecture.id == n.id;
      });
      lecture.favorite = !!inList.length;
      return lecture.favorite;
    };


    var activePopup;
    var openedPopup;

    $scope.calendarData = {
        lecture: null,
        calendar: null,
        reminder: null
    };

    $scope.showCalendars = function(lecture) {

        $scope.calendarData.lecture = lecture;
        $scope.calendarData.calendar = null;
        $scope.calendarData.reminder = null;

        $scope.showCalendarList = false;
        $scope.showReminderList = true;

        // $scope.killPopup();

        $ionicPopup.show({
            templateUrl:  'calendar_list.html',
            atitle: 'U koji kalendar?',
            title: "{{ showCalendarList ? 'U koji kalendar?' : 'Podsjetnik?' }}",
            scope: $scope,
            buttons: [
                {
                    text: 'Odustani',
                    type: 'button-positive',
                    onTap: function(e) {
                        $scope.killPopup();
                        return false;
                    }
                }
            ]
        }).then(function(res) {
            $scope.killPopup();
        }, function(err) {

        }, function(popup) {
            openedPopup = true;
            activePopup = popup;
        });

    }

    $scope.reminders = [null, 15, 30];

    $scope.showReminders = function(calendar) {

        $scope.calendarData.calendar = calendar;

        $scope.showCalendarList = false;
        $scope.showReminderList = true;

        return;

        $scope.closePopup();

        $ionicPopup.show({
            templateUrl:  'reminder_list.html',
            title: 'Podsjetnik?',
            scope: $scope,
            buttons: [
                {
                    text: 'Odustani',
                    onTap: function(e) {
                        return true;
                    }
                }
            ]
        }).then(function(res) {

        }, function(err) {

        }, function(popup) {
            activePopup = popup;
        });

    }

    $scope.closePopup = function() {
        if (activePopup) {
            activePopup.close();
        }
    }

    $scope.killPopup = function() {
        $scope.closePopup();
        $timeout(function () {
            if (activePopup && openedPopup) {
                $('.popup').remove();
                $('.popup-backdrop').remove();
                openedPopup = false;
            }
        }, 200);
    }

    $scope.removeFromCal = function (lecture) {

        $scope.calendarData.lecture = lecture;
        $scope.calendarData.calendar = null;
        $scope.calendarData.reminder = null;

        lecture.inCal = -1;

        Data.removeFromCalendar($scope.calendarData);

    };

    $scope.addToCal = function (reminder) {

        $scope.calendarData.reminder = reminder;

        $scope.killPopup();

        $scope.calendarData.lecture.inCal = -1;

        Data.addToCalendar($scope.calendarData);



        return;

        //var speaker = $scope.getSpeaker(lecture.speaker);
        if (window.plugins && window.plugins.calendar) {
            // window.plugins.calendar.createEventInNamedCalendar(
            //     lecture.title, //title
            //     lecture.location, //location
            //     speaker ? ('Predavač: ' + speaker.name + ' ' + speaker.lastname) : null, //notes
            //     new Date(moment(lecture.date).format()), //startDate
            //     lecture.end ? (new Date(moment(lecture.end).format())) : null, //endDate
            //     $scope.calendarName, //calendarName
            //     function (e) { lecture.inCal = true; }, //success
            //     function (e) {  }  //error
            // );
            window.plugins.calendar.createEvent(
                lecture.title,
                lecture.location,
                speaker ? ('Predavač: ' + speaker.name + ' ' + speaker.lastname) : null,
                new Date(moment(lecture.date).format()),
                lecture.end ? (new Date(moment(lecture.end).format())) : null,
                function (e) { lecture.inCal = true; },
                function (e) {  }
            );
        }
    };

    $scope.calendarName = 'Dani komunikacija';
/*
    ionic.Platform.ready(function(e) {
        $scope.qqqq.push('ready');
        if (window.plugins && window.plugins.calendar) {
            $scope.qqqq.push('plugins');
            //angular.forEach(Data.schedule, function(day) {
                //angular.forEach(day.locations, function(location) {
                    //angular.forEach(location.lectures, function(lecture, i) {
                    var lecture = Data.schedule[0].locations[0].lectures[0];
                    var i = 0;
                        $scope.qqqq.push(i);
                        var speaker = Data.getSpeaker(lecture.speaker);
                        window.plugins.calendar.findEvent(
                            lecture.title,
                            lecture.location,
                            speaker ? ('Predavač: ' + speaker.name + ' ' + speaker.lastname) : '',
                            new Date(moment(lecture.date).format()),
                            lecture.end ? (new Date(moment(lecture.end).format())) : new Date(moment(lecture.date).add('hours', 1).format()),
                            function (e) {  },
                            function (e) {  }
                        );
            //         });
            //     });
            // });
        } else {
            $scope.qqqq.push('pc');
            // angular.forEach(Data.schedule, function(day) {
            //     angular.forEach(day.locations, function(location) {
            //         angular.forEach(location.lectures, function(lecture, i) {
                        var lecture = Data.schedule[0].locations[0].lectures[0];
                        var i = 0;
                        $scope.qqqq.push(i);
                        var speaker = Data.getSpeaker(lecture.speaker);
                        console.log(
                            lecture.title,
                            lecture.location,
                            speaker ? ('Predavač: ' + speaker.name + ' ' + speaker.lastname) : null,
                            new Date(moment(lecture.date).format()),
                            lecture.end ? (new Date(moment(lecture.end).format())) : null,
                            function (e) { $scope.qqqq.push('got'); $scope.qqqq.push(i); $scope.qqqq.push(e); lecture.inCal = true; },
                            function (e) { $scope.qqqq.push('nope'); $scope.qqqq.push(i); }
                        );
            //         });
            //     });
            // });
        }
    });
*/

})

.controller('MainCtrl', function ($scope, $state, $window, Data) {
    console.log('MainCtrl', $scope);
    $scope.news = Data.news;
})

.controller('AboutCtrl', function ($scope, $state) {


})
.controller('ScheduleCtrl', function ($scope, $state, $timeout, $ionicScrollDelegate) {

    // $ionicGesture.on('swiperight', function() {
    //     $scope.goBack();
    // }, angular.element(document.getElementById('Schedule')));

    $timeout(function () {
      var el = document.getElementById('/tab/schedule');
      if (el) {
        $ionicScrollDelegate.scrollTo(0, el.getBoundingClientRect().top - 50, true);
      }
    }, 100);

    // $scope.qqq = [typeof navigator.notification, typeof org];
    // try {
    //     navigator.notification.vibrate(2500);
    // } catch(e) {}

})

.controller('SpeakersCtrl', function ($scope, $state, $ionicGesture, Data) {

    $scope.speakers = Data.speakers;



    // $ionicGesture.on('swiperight', function() {
    //     $scope.goBack();
    // }, angular.element(document.getElementById('Speakers')));

})

.controller('WelcomeCtrl', function ($scope, $timeout, Data) {

    $scope.timer = {
      day: 0,
      hour: 0,
      minute: 0,
      show: false
    };

    $scope.data = Data;

    var timeout;
    var then = moment();
    function checkTime (delay) {
      timeout = $timeout(function () {
        var now = moment();
        $scope.timer.day = then.diff(now, 'd');
        $scope.timer.hour = then.diff(now, 'h') % 24;
        $scope.timer.minute = then.diff(now, 'm') % 60;
        if ($scope.timer.day <= 0 && $scope.timer.hour <= 0 && $scope.timer.minute <= 0) {
          $scope.goTo('tab.home');
          return;
        }
        $scope.timer.show = true;
        checkTime(1000);
      }, delay);
    }

    $scope.$watch('data.formated', function (days, prev) {
      if (days && days.length) {
        then = moment(days[0].lectures[0].event.start);
        checkTime(0);
      }
    });

    $scope.$on('$destroy', function () {
      $timeout.cancel(timeout);
    });

})

.controller('SpeakerCtrl', function ($scope, $state, $ionicGesture, Data, $timeout) {

  $scope.item = null;
  Data.getById($state.params.id).then(function (item) {
    $scope.item = item;
  });
return;
$timeout(function () {
    $scope.speaker = Data.getSpeaker($state.params.id);
    $scope.schedule = Data.getScheduleBySpeaker($state.params.id);
}, 100);

return;
    var el = angular.element(document.getElementById('header'));
        el.css(ionic.CSS.TRANSFORM, 'translate3d(0, 0, 0)');
        el.css('background-size', '100% auto');
    var max = 320;
    var min = 120;

    $scope.height = max;

    $scope.showTitle = true;


    $scope.headerUpdate = function() {
        // ios
        var scroll = angular.element(angular.element(document.getElementById('headerScroll').innerHTML)[0]);
        var pos = parseFloat(scroll.css(ionic.CSS.TRANSFORM).split(',')[1]);
        // max = $(el).width();
        var h = Math.max(min, max + pos);
        //TweenLite.to($scope, .01, { height: h, onUpdate: function() {
            //var h = $scope.height;
            var p = (1 - ((h - min) / (max - min)));
            //el.css(ionic.CSS.TRANSFORM, 'translate3d(0, 0, 0)');
            el.css('height', Math.ceil(h) + 'px');
            //el.css('top', h-max+40 + 'px');
            // console.log(p);
            // el.css(ionic.CSS.TRANSFORM, 'translate3d(0, ' + Math.round(h-max) + 'px, 0)');
            el.css(ionic.CSS.TRANSFORM, 'translate3d(0, 0, 0)');

            if (p < 0) {
                el.css('background-size', 'cover');
                el.css('background-position', '50% 40%');
                // el.css('background-position', '50% 50%');
            } else {
                el.css('background-size', (100 + 50 * p) + '% auto');
                el.css('background-position', '0 40%');
                // el.css('background-position', '0 ' + (.1 * max * p) + 'px');
            }
            el.css('z-index', h == min ? 9999 : 0);
            $scope.$apply(function() {
                $scope.showTitle = h > min;
            });


            p = Math.max(p, 0);
            var bg = angular.element(document.getElementById('headerBg'));
                bg.css(ionic.CSS.TRANSFORM, 'translate3d(0, 0, 0)');
                bg.css('background-image', 'linear-gradient(' + (90 * p) + 'deg, rgba(51, 51, 51, 1) ' + (25 * p) + '%,rgba(51, 51, 51, 0) ' + (50 + 50 * p) + '%)');
        //}});


    };

    $scope.headerUpdateQ = function() {
        // android
        var scroll = angular.element(angular.element(document.getElementById('headerScroll').innerHTML)[0]);
        var pos = parseFloat(scroll.css(ionic.CSS.TRANSFORM).split(',')[1]);
        // max = $(el).width();
        var h = Math.max(min, max + pos);
        //TweenLite.to($scope, .01, { height: h, onUpdate: function() {
            //var h = $scope.height;
            var p = (1 - ((h - min) / (max - min)));
            //el.css(ionic.CSS.TRANSFORM, 'translate3d(0, 0, 0)');
            //el.css('height', Math.ceil(h) + 'px');
            //el.css('top', h-max+40 + 'px');
            // console.log(p);
            el.css(ionic.CSS.TRANSFORM, 'translate3d(0, ' + Math.round(h-max) + 'px, 0)');

            if (p < 0) {
                el.css('background-size', '100% auto');
                //el.css('background-position', '50% 40%');
                el.css('background-position', '50% 50%');
            } else {
                el.css('background-size', (100 + 50 * p) + '% auto');
                //el.css('background-position', '0 40%');
                el.css('background-position', '0 ' + (.1 * max * p) + 'px');
            }
            el.css('z-index', h == min ? 9999 : 0);
            $scope.$apply(function() {
                $scope.showTitle = h > min;
            });


            //p = Math.max(p, 0);
            //var bg = angular.element(document.getElementById('headerBg'));
                //bg.css(ionic.CSS.TRANSFORM, 'translate3d(0, 0, 0)');
                //bg.css('background-image', 'linear-gradient(' + (90 * p) + 'deg, rgba(51, 51, 51, 1) ' + (25 * p) + '%,rgba(51, 51, 51, 0) ' + (50 + 50 * p) + '%)');
        //}});


    };
    //ionic.DomUtil.requestAnimationFrame(console.log);

})

.directive('linkOutside', function () {
  return {
    restrict: 'A',
    link: function (scope, element, attrs) {
      scope.$watch(attrs.ngBindHtml, function () {
        setTimeout(function () {
          element.find('a').on('click', function (e) {
            e.preventDefault();
            scope.open(this.href);
          })
        }, 100);
      }, true);
    }
  };
})

.directive('header', function() {
    return {
        restrict: 'C',
        link: function(scope, element, attrs) {
            var scroll = element.parent();
            scroll.bind('scroll', function(e) {
                var pos = parseFloat(scroll.css(ionic.CSS.TRANSFORM).split(',')[1]);
                //element.css(ionic.CSS.TRANSFORM, 'translate3d(0, ' + (-pos) + 'px, 0)');
                element.css('height', Math.max(120, 320 + pos) + 'px');
            });
        }
    };
});
